#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-

## Copyright 2005 by LivingLogic AG, Bayreuth/Germany.
## Copyright 2005 by Walter Drwald
##
## All Rights Reserved
##
## See orasql.py for the license


import sys

from ll import orasql


if __name__ == "__main__":
	import sys, optparse

	p = optparse.OptionParser(usage="usage: %prog [options] connectstring >output.sql")
	p.add_option("-v", "--verbose", dest="verbose", help="Give a progress report?", default=False, action="store_true")
	p.add_option("-x", "--execute", metavar="CONNECTSTRING2", dest="execute", help="Execute in target database", type="str")
	p.add_option("-k", "--keepdollar", dest="keepdollar", help="Output objects with '$' in their name?", default=False, action="store_true")

	(options, args) = p.parse_args()
	if len(args) != 1:
		p.error("incorrect number of arguments")
		sys.exit(1)

	connection = orasql.connect(args[0])
	cursor = connection.cursor()

	if options.execute:
		connection2 = orasql.connect(options.execute)
		cursor2 = connection2.cursor()
		term = False
	else:
		term = True

	for definition in cursor.iterobjects(mode="create", all=False):
		keep = definition.owner is None and ("$" not in definition.name or options.keepdollar)
		if options.verbose:
			msg = "%s: %s: %r" % (sys.argv[0], cursor.connection.connectstring(), definition)
			if not keep:
				msg += " (skipped)"
			print >>sys.stderr, msg
		if keep:
			ddl = definition.createddl(cursor, term)
			if ddl:
				if options.execute:
					cursor2.execute(ddl)
				else:
					print ddl
					print
